'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _events = require('events');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Adapter = function (_EventEmitter) {
  _inherits(Adapter, _EventEmitter);

  function Adapter(robot) {
    _classCallCheck(this, Adapter);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Adapter).call(this));

    _this.robot = robot;
    return _this;
  }

  /**
   * Public: Raw method for sending data back to the chat source. Extend this.
   *
   * @param {object} envelope - A Object with message, room and user details.
   * @param {string} strings  - One or more Strings for each message to send.
   *
   * Returns nothing.
   */


  _createClass(Adapter, [{
    key: 'send',
    value: function send(envelope) {
      this.envelope = envelope;

      for (var _len = arguments.length, strings = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        strings[_key - 1] = arguments[_key];
      }

      this.strings = strings;
    }

    /**
     * Public: Raw method for sending emote data back to the chat source.
     * Defaults as an alias for send
     *
     * @param {object} envelope - A Object with message, room and user details.
     * @param {string} strings  - One or more Strings for each message to send.
     *
     * Returns nothing.
     */

  }, {
    key: 'emote',
    value: function emote(envelope) {
      this.envelope = envelope;

      for (var _len2 = arguments.length, strings = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        strings[_key2 - 1] = arguments[_key2];
      }

      this.strings = strings;
      this.send.apply(this, [envelope].concat(strings));
    }

    /**
     * Public: Raw method for building a reply and sending it back to the chat
     * source. Extend this.
     *
     * @param {object} envelope - A Object with message, room and user details.
     * @param {string} strings  - One or more Strings for each message to send.
     *
     * Returns nothing.
     */

  }, {
    key: 'reply',
    value: function reply(envelope) {
      this.envelope = envelope;

      for (var _len3 = arguments.length, strings = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
        strings[_key3 - 1] = arguments[_key3];
      }

      this.strings = strings;
    }

    /**
     * Public: Raw method for setting a topic on the chat source. Extend this.
     *
     * @param {object} envelope - A Object with message, room and user details.
     * @param {string} strings  - One or more Strings for each message to send.
     *
     * Returns nothing.
     */

  }, {
    key: 'topic',
    value: function topic(envelope) {
      this.envelope = envelope;

      for (var _len4 = arguments.length, strings = Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
        strings[_key4 - 1] = arguments[_key4];
      }

      this.strings = strings;
    }

    /**
     * Public: Raw method for playing a sound in the chat source. Extend this.
     *
     * @param {object} envelope - A Object with message, room and user details.
     * @param {string} strings  - One or more Strings for each message to send.
     *
     * Returns nothing.
     */

  }, {
    key: 'play',
    value: function play(envelope) {
      this.envelope = envelope;

      for (var _len5 = arguments.length, strings = Array(_len5 > 1 ? _len5 - 1 : 0), _key5 = 1; _key5 < _len5; _key5++) {
        strings[_key5 - 1] = arguments[_key5];
      }

      this.strings = strings;
    }

    /**
     * Public: Raw method for invoking the bot to run. Extend this.
     *
     * Returns nothing.
     */

  }, {
    key: 'run',
    value: function run() {}

    /**
     * Public: Raw method for shutting the bot down. Extend this.
     *
     * Returns nothing.
     */

  }, {
    key: 'close',
    value: function close() {}

    /**
     * Public: Dispatch a received message to the robot.
     *
     * Returns nothing.
     */

  }, {
    key: 'receive',
    value: function receive(message) {
      this.robot.receive(message);
    }
  }]);

  return Adapter;
}(_events.EventEmitter);

exports.default = Adapter;