'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.use = use;

var _fs = require('fs');

var fs = _interopRequireWildcard(_fs);

var _readline = require('readline');

var readline = _interopRequireWildcard(_readline);

var _stream = require('stream');

var _stream2 = _interopRequireDefault(_stream);

var _cline = require('cline');

var _cline2 = _interopRequireDefault(_cline);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _robot = require('../robot');

var _robot2 = _interopRequireDefault(_robot);

var _adapter = require('../adapter');

var _adapter2 = _interopRequireDefault(_adapter);

var _message = require('../message');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var historySize = process.env.WEBBY_SHELL_HISTSIZE != null ? parseInt(process.env.WEBBY_SHELL_HISTSIZE) : 1024;

var historyPath = '.webby_history';

console.log('shell adapter loaded');

var Shell = function (_Adapter) {
  _inherits(Shell, _Adapter);

  function Shell() {
    _classCallCheck(this, Shell);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Shell).apply(this, arguments));
  }

  _createClass(Shell, [{
    key: 'send',
    value: function send(envelope) {
      for (var _len = arguments.length, strings = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        strings[_key - 1] = arguments[_key];
      }

      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = strings[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var str = _step.value;

          console.log(_chalk2.default.bold(str));
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }
  }, {
    key: 'emote',
    value: function emote(envelope) {
      for (var _len2 = arguments.length, strings = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        strings[_key2 - 1] = arguments[_key2];
      }

      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = strings[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var str = _step2.value;

          this.send(envelope, '* ' + str);
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }
    }
  }, {
    key: 'reply',
    value: function reply(envelope) {
      for (var _len3 = arguments.length, strings = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
        strings[_key3 - 1] = arguments[_key3];
      }

      strings = strings.map(function (s) {
        return ' ' + envelope.user.name + ': ' + s;
      });
      return this.send(envelope, strings);
    }
  }, {
    key: 'run',
    value: function run() {
      var _this2 = this;

      this.buildCli();
      loadHistory(function (history) {
        _this2.cli.history(history);
        _this2.cli.interact(_this2.robot.name + '> ');
        _this2.emit('connected');
      });
    }
  }, {
    key: 'shutdown',
    value: function shutdown() {
      this.robot.shutdown();
      process.exit(0);
    }
  }, {
    key: 'buildCli',
    value: function buildCli() {
      var _this3 = this;

      this.cli = (0, _cline2.default)();
      this.cli.command('*', function (input) {
        var userId = process.env.HUBOT_SHELL_USER_ID || process.env.WEBBY_SHELL_USER_ID || '1';
        if (userId.match(/\A\d+\z/)) {
          userId = parseInt(userId);
        }
        var userName = process.env.HUBOT_SHELL_USER_NAME || process.env.WEBBY_SHELL_USER_NAME || 'Shell';
        var user = _this3.robot.brain.userForId(userId, {
          name: userName,
          room: 'Shell'
        });
        _this3.receive(new _message.TextMessage(user, input, 'messageId'));
      });

      this.cli.command('history', function () {
        var ref = _this3.cli.history();
        var _iteratorNormalCompletion3 = true;
        var _didIteratorError3 = false;
        var _iteratorError3 = undefined;

        try {
          for (var _iterator3 = ref[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
            var item = _step3.value;

            console.log(item);
          }
        } catch (err) {
          _didIteratorError3 = true;
          _iteratorError3 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion3 && _iterator3.return) {
              _iterator3.return();
            }
          } finally {
            if (_didIteratorError3) {
              throw _iteratorError3;
            }
          }
        }
      });

      this.cli.on('history', function (item) {
        if (item.length > 0 && item !== 'exit' && item !== 'history') {
          return fs.appendFile(historyPath, item + '\n', function (err) {
            if (err) {
              return _this3.robot.emit('error', err);
            }
          });
        }
      });

      this.cli.on('close', function () {
        var history = _this3.cli.history();
        if (history.length > historySize) {
          var startIndex = history.length - historySize;
          history = history.reverse().splice(startIndex, historySize);
          var outstream = fs.createWriteStream(historyPath);
          outstream.on('finish', function () {
            return _this3.shutdown();
          });
          var _iteratorNormalCompletion4 = true;
          var _didIteratorError4 = false;
          var _iteratorError4 = undefined;

          try {
            for (var _iterator4 = history[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
              var item = _step4.value;

              outstream.write(item + '\n');
            }
          } catch (err) {
            _didIteratorError4 = true;
            _iteratorError4 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion4 && _iterator4.return) {
                _iterator4.return();
              }
            } finally {
              if (_didIteratorError4) {
                throw _iteratorError4;
              }
            }
          }

          outstream.end(function () {
            _this3.shutdown();
          });
        } else {
          _this3.shutdown();
        }
      });
    }
  }]);

  return Shell;
}(_adapter2.default);

/**
 *Private: load history from .webby_history.
 *
 * callback - A Function that is called with the loaded history items (or an empty array if there is no history)
 */


var loadHistory = function loadHistory(callback) {
  return fs.exists(historyPath, function (exists) {
    if (exists) {
      (function () {
        var instream = fs.createReadStream(historyPath);
        var outstream = new _stream2.default();
        outstream.readable = true;
        outstream.writable = true;
        var items = [];
        var rl = readline.createInterface({
          input: instream,
          output: outstream,
          terminal: false
        });
        rl.on('line', function (line) {
          line = line.trim();
          if (line.length > 0) {
            return items.push(line);
          }
        });
        rl.on('close', function () {
          callback(items);
        });
      })();
    } else {
      callback([]);
    }
  });
};

function use(robot) {
  return new Shell(robot);
};